Takahiro Suzuki | 241c10e | 2020-12-17 20:17:57 +0900 | [diff] [blame] | 1 | # |
| 2 | # Copyright 2016 the original author or authors. |
| 3 | # |
| 4 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 5 | # you may not use this file except in compliance with the License. |
| 6 | # You may obtain a copy of the License at |
| 7 | # |
| 8 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 9 | # |
| 10 | # Unless required by applicable law or agreed to in writing, software |
| 11 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 12 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 13 | # See the License for the specific language governing permissions and |
| 14 | # limitations under the License. |
| 15 | # |
| 16 | |
| 17 | # set default shell |
| 18 | SHELL = bash -e -o pipefail |
| 19 | |
| 20 | # Variables |
| 21 | VERSION ?= $(shell cat ./VERSION) |
| 22 | |
| 23 | DOCKER_LABEL_VCS_DIRTY = false |
| 24 | ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0) |
| 25 | DOCKER_LABEL_VCS_DIRTY = true |
| 26 | endif |
| 27 | ## Docker related |
| 28 | DOCKER_EXTRA_ARGS ?= |
| 29 | DOCKER_REGISTRY ?= |
| 30 | DOCKER_REPOSITORY ?= |
| 31 | DOCKER_TAG ?= ${VERSION} |
Kengof20xx | 0ed5eeb | 2020-12-21 14:35:41 +0900 | [diff] [blame^] | 32 | ADAPTER_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-epononu-adapter:1.1.0 |
Takahiro Suzuki | 241c10e | 2020-12-17 20:17:57 +0900 | [diff] [blame] | 33 | TYPE ?= minimal |
| 34 | |
| 35 | ## Docker labels. Only set ref and commit date if committed |
| 36 | DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote)) |
| 37 | DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD) |
| 38 | DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ") |
| 39 | DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD) |
| 40 | |
| 41 | DOCKER_BUILD_ARGS ?= \ |
| 42 | ${DOCKER_EXTRA_ARGS} \ |
| 43 | --build-arg org_label_schema_version="${VERSION}" \ |
| 44 | --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \ |
| 45 | --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \ |
| 46 | --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \ |
| 47 | --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \ |
| 48 | --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}" |
| 49 | |
| 50 | # tool containers |
| 51 | VOLTHA_TOOLS_VERSION ?= 2.0.0 |
| 52 | |
| 53 | GO = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang go |
| 54 | GO_JUNIT_REPORT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-go-junit-report go-junit-report |
| 55 | GOCOVER_COBERTURA = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -i voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-gocover-cobertura gocover-cobertura |
| 56 | GOFMT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golang gofmt |
| 57 | GOLANGCI_LINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app -v gocache:/.cache -v gocache-${VOLTHA_TOOLS_VERSION}:/go/pkg voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-golangci-lint golangci-lint |
| 58 | HADOLINT = docker run --rm --user $$(id -u):$$(id -g) -v ${CURDIR}:/app voltha/voltha-ci-tools:${VOLTHA_TOOLS_VERSION}-hadolint hadolint |
| 59 | |
| 60 | .PHONY: docker-build local-protos local-lib-go |
| 61 | |
| 62 | # This should to be the first and default target in this Makefile |
| 63 | help: |
| 64 | @echo "Usage: make [<target>]" |
| 65 | @echo "where available targets are:" |
| 66 | @echo "" |
| 67 | @echo "clean : Removes any local filesystem artifacts generated by a build" |
| 68 | @echo "distclean : Removes any local filesystem artifacts generated by a build or test run" |
| 69 | @echo "build : Build all openonu adapter artifacts" |
| 70 | @echo "docker-build : Build openonu adapter docker image" |
| 71 | @echo "docker-push : Push the docker images to an external repository" |
| 72 | @echo "help : Print this help" |
| 73 | @echo "lint : Run all lint targets" |
| 74 | @echo "lint-dockerfile : Perform static analysis on Dockerfiles" |
| 75 | @echo "lint-mod : Verify the Go dependencies" |
| 76 | @echo "lint-sanity : Run the Go language sanity tests (vet)" |
| 77 | @echo "lint-style : Verify the Go standard format of the source" |
| 78 | @echo "local-protos : Copies a local verison of the VOLTHA protos into the vendor directory" |
| 79 | @echo "local-lib-go : Copies a local version of the VOTLHA dependencies into the vendor directory" |
| 80 | @echo "sca : Runs various SCA through golangci-lint tool" |
| 81 | @echo "test : Run unit tests, if any" |
| 82 | @echo |
| 83 | |
| 84 | ## Local Development Helpers |
| 85 | |
| 86 | local-protos: |
| 87 | ifdef LOCAL_PROTOS |
| 88 | rm -rf vendor/github.com/opencord/voltha-protos/v3/go |
| 89 | mkdir -p vendor/github.com/opencord/voltha-protos/v3/go |
| 90 | cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v3/go |
| 91 | rm -rf vendor/github.com/opencord/voltha-protos/v3/go/vendor |
| 92 | endif |
| 93 | |
| 94 | ## Local Development Helpers |
| 95 | local-lib-go: |
| 96 | ifdef LOCAL_LIB_GO |
| 97 | mkdir -p vendor/github.com/opencord/voltha-lib-go/v3/pkg |
| 98 | cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v3/pkg/ |
| 99 | endif |
| 100 | |
| 101 | ## Docker targets |
| 102 | |
| 103 | build: docker-build |
| 104 | |
| 105 | docker-build: local-protos local-lib-go |
| 106 | docker build $(DOCKER_BUILD_ARGS) -t ${ADAPTER_IMAGENAME} -f docker/Dockerfile.epononu . |
| 107 | |
| 108 | docker-push: |
| 109 | docker push ${ADAPTER_IMAGENAME} |
| 110 | |
| 111 | docker-kind-load: |
| 112 | @if [ "`kind get clusters | grep voltha-$(TYPE)`" = '' ]; then echo "no voltha-$(TYPE) cluster found" && exit 1; fi |
| 113 | kind load docker-image ${ADAPTER_IMAGENAME} --name=voltha-$(TYPE) --nodes $(shell kubectl get nodes --template='{{range .items}}{{.metadata.name}},{{end}}' | sed 's/,$$//') |
| 114 | |
| 115 | |
| 116 | ## lint and unit tests |
| 117 | |
| 118 | lint-dockerfile: |
| 119 | @echo "Running Dockerfile lint check ..." |
| 120 | @${HADOLINT} $$(find . -name "Dockerfile.*") |
| 121 | @echo "Dockerfile lint check OK" |
| 122 | |
| 123 | lint-style: |
| 124 | @echo "Running style check..." |
| 125 | @gofmt_out="$$(${GOFMT} -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\ |
| 126 | if [ ! -z "$$gofmt_out" ]; then \ |
| 127 | echo "$$gofmt_out" ;\ |
| 128 | echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\ |
| 129 | exit 1 ;\ |
| 130 | fi |
| 131 | @echo "Style check OK" |
| 132 | |
| 133 | lint-sanity: |
| 134 | @echo "Running sanity check..." |
| 135 | @${GO} vet -mod=vendor ./... |
| 136 | @echo "Sanity check OK" |
| 137 | |
| 138 | lint-mod: |
| 139 | @echo "Running dependency check..." |
| 140 | @${GO} mod verify |
| 141 | @echo "Dependency check OK. Running vendor check..." |
| 142 | @git status > /dev/null |
| 143 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1) |
| 144 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1) |
| 145 | ${GO} mod tidy |
| 146 | ${GO} mod vendor |
| 147 | @git status > /dev/null |
| 148 | @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| 149 | @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1) |
| 150 | @echo "Vendor check OK." |
| 151 | |
| 152 | lint: local-lib-go lint-style lint-sanity lint-mod lint-dockerfile |
| 153 | |
| 154 | test: lint |
| 155 | @mkdir -p ./tests/results |
Kengof20xx | 0ed5eeb | 2020-12-21 14:35:41 +0900 | [diff] [blame^] | 156 | @${GO} test -mod=vendor -timeout 60m -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\ |
Takahiro Suzuki | 241c10e | 2020-12-17 20:17:57 +0900 | [diff] [blame] | 157 | RETURN=$$? ;\ |
| 158 | ${GO_JUNIT_REPORT} < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\ |
| 159 | ${GOCOVER_COBERTURA} < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\ |
| 160 | exit $$RETURN |
| 161 | |
| 162 | sca: |
| 163 | @mkdir -p ./sca-report |
| 164 | @echo "Running static code analysis..." |
| 165 | @${GOLANGCI_LINT} run --deadline=4m --out-format junit-xml ./... | tee ./sca-report/sca-report.xml |
| 166 | @echo "Static code analysis OK" |
| 167 | |
| 168 | clean: distclean |
| 169 | |
| 170 | distclean: |
| 171 | rm -rf ./sca-report |
| 172 | |
| 173 | mod-update: |
| 174 | ${GO} mod tidy |
| 175 | ${GO} mod vendor |